<idea-plugin xmlns:xi="http://www.w3.org/2001/XInclude">
    <xi:include href="/META-INF/android-kotlin-extensions.xml" xpointer="xpointer(/idea-plugin/*)"/>

    <extensionPoints>
        <extensionPoint qualifiedName="org.jetbrains.kotlin.androidDexer"
                        interface="org.jetbrains.kotlin.idea.debugger.evaluate.classLoading.AndroidDexer"
                        area="IDEA_PROJECT"/>
    </extensionPoints>

    <extensions defaultExtensionNs="com.intellij">

        <completion.contributor language="kotlin" implementationClass="org.jetbrains.kotlin.android.AndroidKotlinCompletionContributor" order="first, before KotlinCompletionContributor"/>

        <localInspection implementationClass="org.jetbrains.kotlin.android.inspection.IllegalIdentifierInspection"
                         displayName="Illegal Android Identifier"
                         groupName="Kotlin Android"
                         enabledByDefault="true"
                         level="ERROR"/>

        <localInspection implementationClass="org.jetbrains.kotlin.android.inspection.TypeParameterFindViewByIdInspection"
                         displayName="Cast can be converted to findViewById with type parameter"
                         groupName="Kotlin Android"
                         enabledByDefault="true"
                         cleanupTool="true"
                         level="WEAK WARNING"
                         language="kotlin" />

        <intentionAction>
            <className>org.jetbrains.kotlin.android.intention.KotlinAndroidAddStringResource</className>
            <category>Kotlin Android</category>
        </intentionAction>


        <intentionAction>
            <className>org.jetbrains.kotlin.android.intention.AddActivityToManifest</className>
            <category>Kotlin Android</category>
        </intentionAction>

        <intentionAction>
            <className>org.jetbrains.kotlin.android.intention.AddServiceToManifest</className>
            <category>Kotlin Android</category>
        </intentionAction>

        <intentionAction>
            <className>org.jetbrains.kotlin.android.intention.AddBroadcastReceiverToManifest</className>
            <category>Kotlin Android</category>
        </intentionAction>
        <intentionAction>
            <className>org.jetbrains.kotlin.android.intention.ImplementParcelableAction</className>
            <category>Kotlin Android</category>
        </intentionAction>

        <intentionAction>
            <className>org.jetbrains.kotlin.android.intention.RemoveParcelableAction</className>
            <category>Kotlin Android</category>
        </intentionAction>

        <intentionAction>
            <className>org.jetbrains.kotlin.android.intention.RedoParcelableAction</className>
            <category>Kotlin Android</category>
        </intentionAction>

        <codeInsight.unresolvedReferenceQuickFixProvider
            implementation="org.jetbrains.kotlin.android.inspection.KotlinAndroidResourceQuickFixProvider"/>

        <lang.foldingBuilder language="kotlin" implementationClass="org.jetbrains.kotlin.android.folding.ResourceFoldingBuilder" />

        <externalAnnotator language="kotlin" implementationClass="org.jetbrains.kotlin.android.AndroidKotlinResourceExternalAnnotator" />

        <registryKey key="kotlin.android.import.mpp.all.transitive"
                     description="Add all transitive dependencies on MPP modules when Android project is imported"
                     defaultValue="true"
                     restartRequired="false"/>
    </extensions>


    <extensions defaultExtensionNs="org.jetbrains.kotlin">
        <quickFixContributor implementation="org.jetbrains.kotlin.android.quickfix.AndroidQuickFixRegistrar"/>
        <projectConfigurator implementation="org.jetbrains.kotlin.android.configure.KotlinAndroidGradleModuleConfigurator"/>

        <androidDexer implementation="org.jetbrains.kotlin.android.debugger.AndroidDexerImpl"/>

        <highlighterExtension implementation="org.jetbrains.kotlin.android.AndroidHighlighterExtension"/>
        <quickFixContributor implementation="com.android.tools.idea.imports.AndroidMavenImportKotlinResolver"/>
        <resolveScopeEnlarger implementation="org.jetbrains.kotlin.android.AndroidKotlinResolveScopeEnlarger"/>
        <renameHandler implementation="org.jetbrains.android.refactoring.renaming.KotlinResourceRenameHandler" order="first"/>
    </extensions>

    <extensions defaultExtensionNs="com.android.tools.idea.lint.common">
        <lintQuickFixProvider implementation="org.jetbrains.kotlin.android.quickfix.KotlinAndroidQuickFixProvider" />
    </extensions>
</idea-plugin>
